export declare const version = "v1.3.2";
export interface ConfigKeys {
    varsnap: string;
    env: string;
    producerToken: string;
    consumerToken: string;
    logger: Logger;
}
export declare const configKeys: ConfigKeys;
export interface Logger {
    debug(s: string): void;
    log(s: string): void;
    error(s: string): void;
}
export declare class Util {
    static logger: Logger;
    static getConfig(config: any, configKey: any): string;
    static getSignature(targetFunc: TargetFunction): string;
    static ajax(url: any, requestData: any): Promise<object>;
    static debug(data: any): void;
    static log(data: any): void;
    static error(data: any): void;
    static resetProducers(): void;
    static resetConsumers(): void;
    static getProducers(): Producer[];
    static getConsumers(): Consumer[];
    static limitString(x: TargetFunctionInput[] | TargetFunctionOutput): string;
}
export declare class Producer {
    targetFunc: any;
    config: any;
    constructor(targetFunc: any, config: any);
    isEnabled(): boolean;
    static serialize(data: TargetFunctionInput[] | TargetFunctionOutput): string;
    produce(args: TargetFunctionInput[], output: TargetFunctionOutput): void;
}
interface Snap {
    id: string;
    inputs: string;
    prod_outputs: string;
}
export declare class Consumer {
    targetFunc: any;
    config: any;
    constructor(targetFunc: any, config: any);
    isEnabled(): boolean;
    static deserialize(data: string): TargetFunctionInput[] | TargetFunctionOutput;
    consumeOnce(): Promise<boolean>;
    reportCentral(snap: Snap, localOutputs: TargetFunctionOutput, matches: boolean): Promise<string | boolean>;
    reportLog(snapID: string, inputs: TargetFunctionInput[], prodOutputs: TargetFunctionOutput, localOutputs: TargetFunctionOutput, matches: boolean, trialURL: string | boolean): void;
}
export interface TargetFunctionInput {
}
export interface TargetFunctionOutput {
}
export interface TargetFunction {
    (...args: TargetFunctionInput[]): TargetFunctionOutput;
}
export interface WrappedFunction {
    (...args: TargetFunctionInput[]): TargetFunctionOutput;
    producer: Producer;
    consumer: Consumer;
}
export declare function varsnap(func: TargetFunction): TargetFunction | WrappedFunction;
export declare namespace varsnap {
    var config: ConfigKeys;
    var version: string;
    var runTests: typeof import("./core").runTests;
}
export declare function runTests(): Promise<boolean>;
export {};
